---
name: "\U0001F41B Pull Request"
about: Fix a bug or create new example

---

## Description

Please include a summary of the newly proposed example or issue being fixed. Please also include relevant motivation, context.

If this is a new example, how is your example different enough from the remaining examples in the repo. 

If this is a bug fix please link the issue you are fixing. Fixes #(issue)

## Type of change

Please delete options that are not relevant.

- [ ] Bug fix (non-breaking change which fixes an issue)
- [ ] New Example (new example contribution)
- [ ] Breaking change (fix or feature that would cause existing functionality to not work as expected)
- [ ] This change requires a documentation update

## Feature/Issue validation/testing

Please describe the tests [UT/IT] that you ran to verify your changes and relevant result summary. If this is a bug fix please run `run_python_examples.sh` before and after your change locally to make sure it works and add the logs here.

- [ ] Logs before change
- [ ] Logs after change

- Logs

If this is a new example please add a corresponding test in `run_python_examples.sh`

- [ ] Test Added

## Checklist:

- [ ] Have you added tests that prove your fix is effective or that this example works?
- [ ] Has code been commented, particularly in hard-to-understand areas?
- [ ] Have you made corresponding changes to the documentation?
